/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GetGatewaysConnections200ResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetGatewaysConnections200ResponseInner{}

// GetGatewaysConnections200ResponseInner struct for GetGatewaysConnections200ResponseInner
type GetGatewaysConnections200ResponseInner struct {
	Id *string `json:"id,omitempty"`
	PhoneNumber *string `json:"phone_number,omitempty"`
	PhoneName *string `json:"phone_name,omitempty"`
	Status *string `json:"status,omitempty"`
	Error *string `json:"error,omitempty"`
}

// NewGetGatewaysConnections200ResponseInner instantiates a new GetGatewaysConnections200ResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetGatewaysConnections200ResponseInner() *GetGatewaysConnections200ResponseInner {
	this := GetGatewaysConnections200ResponseInner{}
	return &this
}

// NewGetGatewaysConnections200ResponseInnerWithDefaults instantiates a new GetGatewaysConnections200ResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetGatewaysConnections200ResponseInnerWithDefaults() *GetGatewaysConnections200ResponseInner {
	this := GetGatewaysConnections200ResponseInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *GetGatewaysConnections200ResponseInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetGatewaysConnections200ResponseInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *GetGatewaysConnections200ResponseInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *GetGatewaysConnections200ResponseInner) SetId(v string) {
	o.Id = &v
}

// GetPhoneNumber returns the PhoneNumber field value if set, zero value otherwise.
func (o *GetGatewaysConnections200ResponseInner) GetPhoneNumber() string {
	if o == nil || IsNil(o.PhoneNumber) {
		var ret string
		return ret
	}
	return *o.PhoneNumber
}

// GetPhoneNumberOk returns a tuple with the PhoneNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetGatewaysConnections200ResponseInner) GetPhoneNumberOk() (*string, bool) {
	if o == nil || IsNil(o.PhoneNumber) {
		return nil, false
	}
	return o.PhoneNumber, true
}

// HasPhoneNumber returns a boolean if a field has been set.
func (o *GetGatewaysConnections200ResponseInner) HasPhoneNumber() bool {
	if o != nil && !IsNil(o.PhoneNumber) {
		return true
	}

	return false
}

// SetPhoneNumber gets a reference to the given string and assigns it to the PhoneNumber field.
func (o *GetGatewaysConnections200ResponseInner) SetPhoneNumber(v string) {
	o.PhoneNumber = &v
}

// GetPhoneName returns the PhoneName field value if set, zero value otherwise.
func (o *GetGatewaysConnections200ResponseInner) GetPhoneName() string {
	if o == nil || IsNil(o.PhoneName) {
		var ret string
		return ret
	}
	return *o.PhoneName
}

// GetPhoneNameOk returns a tuple with the PhoneName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetGatewaysConnections200ResponseInner) GetPhoneNameOk() (*string, bool) {
	if o == nil || IsNil(o.PhoneName) {
		return nil, false
	}
	return o.PhoneName, true
}

// HasPhoneName returns a boolean if a field has been set.
func (o *GetGatewaysConnections200ResponseInner) HasPhoneName() bool {
	if o != nil && !IsNil(o.PhoneName) {
		return true
	}

	return false
}

// SetPhoneName gets a reference to the given string and assigns it to the PhoneName field.
func (o *GetGatewaysConnections200ResponseInner) SetPhoneName(v string) {
	o.PhoneName = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *GetGatewaysConnections200ResponseInner) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetGatewaysConnections200ResponseInner) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *GetGatewaysConnections200ResponseInner) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *GetGatewaysConnections200ResponseInner) SetStatus(v string) {
	o.Status = &v
}

// GetError returns the Error field value if set, zero value otherwise.
func (o *GetGatewaysConnections200ResponseInner) GetError() string {
	if o == nil || IsNil(o.Error) {
		var ret string
		return ret
	}
	return *o.Error
}

// GetErrorOk returns a tuple with the Error field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetGatewaysConnections200ResponseInner) GetErrorOk() (*string, bool) {
	if o == nil || IsNil(o.Error) {
		return nil, false
	}
	return o.Error, true
}

// HasError returns a boolean if a field has been set.
func (o *GetGatewaysConnections200ResponseInner) HasError() bool {
	if o != nil && !IsNil(o.Error) {
		return true
	}

	return false
}

// SetError gets a reference to the given string and assigns it to the Error field.
func (o *GetGatewaysConnections200ResponseInner) SetError(v string) {
	o.Error = &v
}

func (o GetGatewaysConnections200ResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetGatewaysConnections200ResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.PhoneNumber) {
		toSerialize["phone_number"] = o.PhoneNumber
	}
	if !IsNil(o.PhoneName) {
		toSerialize["phone_name"] = o.PhoneName
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.Error) {
		toSerialize["error"] = o.Error
	}
	return toSerialize, nil
}

type NullableGetGatewaysConnections200ResponseInner struct {
	value *GetGatewaysConnections200ResponseInner
	isSet bool
}

func (v NullableGetGatewaysConnections200ResponseInner) Get() *GetGatewaysConnections200ResponseInner {
	return v.value
}

func (v *NullableGetGatewaysConnections200ResponseInner) Set(val *GetGatewaysConnections200ResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableGetGatewaysConnections200ResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableGetGatewaysConnections200ResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetGatewaysConnections200ResponseInner(val *GetGatewaysConnections200ResponseInner) *NullableGetGatewaysConnections200ResponseInner {
	return &NullableGetGatewaysConnections200ResponseInner{value: val, isSet: true}
}

func (v NullableGetGatewaysConnections200ResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetGatewaysConnections200ResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


